<?php
class App_Expert_Route{
    public static function get($name_space,$route,$action,$args,$validatior=null,$permission_callback='__return_true'){
        self::register(WP_REST_Server::READABLE,$name_space,$route,$action,$args,$validatior,$permission_callback);
    }
    public static function post($name_space,$route,$action,$args,$validatior=null,$permission_callback='__return_true'){
        self::register(WP_REST_Server::CREATABLE,$name_space,$route,$action,$args,$validatior,$permission_callback);
    }
    public static function put($name_space,$route,$action,$args,$validatior=null,$permission_callback='__return_true'){
        self::register(WP_REST_Server::EDITABLE,$name_space,$route,$action,$args,$validatior,$permission_callback);
    }
    public static function delete($name_space,$route,$action,$args,$validatior=null,$permission_callback='__return_true'){
        self::register(WP_REST_Server::DELETABLE,$name_space,$route,$action,$args,$validatior,$permission_callback);
    }
    private static function register($method, $name_space, $route, $action, $args, $validator,$permission_callback){
        register_rest_route($name_space,$route, array(
            'methods'             => $method,
            'callback'            => array("App_Expert_Route","add"),
            'permission_callback' => $permission_callback,
            'args'                => $args,
            'action'              => $action,
            'validator'           => $validator,
        ));
    }
    public static function add(WP_REST_Request $request){

        $attr=$request->get_attributes();
        if(empty($attr['action'])) return App_Expert_Response::fail("invalid_action","no_action_added",[]);

        $callback=explode("@",$attr["action"]);
        if(count($callback)<1) return App_Expert_Response::fail("invalid_action","invalid_action_format",[]);
        $call_back_class=$callback[0];
        $call_back_method=$callback[1];
        $validator= $attr["validator"] ?? "App_Expert_Request";
        try{

            $validation_class=new $validator($request);
            if($validation_class->validate()){
                return (new $call_back_class())->$call_back_method($request);
            }
            $error = $validation_class->getErrors();
            return count($error)?$error[0]:new WP_Error("something_went_wrong","error from App_Expert_Routes:add",[]);
        }catch (Exception $e){
            return App_Expert_Response::fail("something_went_wrong",$e->getMessage(),[]);
        }
    }

}