<?php

class App_Expert_Product_Endpoint extends WC_REST_Products_Controller
{
    public function fetch_variation(WP_REST_Request $request){

        $product_id=$request->get_param('product_id');
        $prod = wc_get_product($product_id);

        $attrs=$request->get_param('attributes');
        $attributes=[];
        foreach ($attrs as $attr){
            $attr_name=strtolower($attr['name']);
            $prefix="attribute_";
            if($attr["id"]){
                $attr_name="pa_".strtolower($attr['name']);
                $term=get_term_by('name',$attr['value'],$attr_name);
                $attr['value']=$term->slug;
            }
            $attributes[$prefix.$attr_name]=$attr['value'];
        }
        $_store=new \WC_Product_Data_Store_CPT();

        $variation_id= $_store->find_matching_product_variation($prod, $attributes);

        if($variation_id>0){
            $new_req=new WP_REST_Request();
            $new_req->set_param('id',$variation_id);
            return $this->get_item($new_req);
        }
        //todo:Enhancement use App_Expert_Response
        return new WP_Error("invalid_selection",__("No product found with the selected values",'woocommerce'),["status"=>422]);
    }
}