<?php
class App_Expert_Checkout_Authentication
{


    private $_current_integration;
    public function __construct(App_Expert_Integration $_current_integration)
    {
        $this->_current_integration = $_current_integration;
        add_filter('init', array($this, 'autenticate_woocommerce_checkout'), 10);
    }




    public function autenticate_woocommerce_checkout()
    {

        $checkout_page = App_Expert_app_Custom_Checkout_Helper::is_checkout_custom_page();
        if (!$checkout_page || is_admin()) {
            return;
        }

        $request_uri = $_SERVER['REQUEST_URI'];
        // Guest user case
        if (isset($_GET['guest_user']) && !empty($_GET['guest_user'])) {  // Guest case
            if (!empty(get_current_user_id())) {
                $this->clear_current_user();
                wp_redirect($request_uri);
                exit;
            }
            return;
        }

        $authorization_header = '';
        if (isset($_GET['user_token']) && !empty($_GET['user_token'])) {
            $authorization_header = "Bearer " . $_GET['user_token'];
        }


        // Authenticated user case
        $token_auth_result = App_Expert_Api_jwt_Token_Helper::authenticate_user_token($authorization_header);
        if (!is_wp_error($token_auth_result)) {

            $user_id = $token_auth_result;
            if ($user_id != get_current_user_id()) {
                $this->open_user_session($user_id);
                wp_redirect($_SERVER['REQUEST_URI']);
                exit;
            }
        } else {
            wp_die("You are not authorized to access this page");
        }
    }


    protected function clear_current_user()
    {
        wp_clear_auth_cookie();
        wp_destroy_current_session();
    }

    protected function open_user_session($user_id)
    {
        $user = get_user_by('ID', $user_id);

        clean_user_cache($user->ID);
        $this->clear_current_user();

        wp_set_current_user($user->ID);
        wp_set_auth_cookie($user->ID, true, false);
        update_user_caches($user);
    }

}

