<?php
Class App_Expert_Wordpress_Init extends App_Expert_Integration {
    function get_dir(){
        return plugin_dir_path(__FILE__);
    }
    public function _include_hooks() {
        parent::_include_hooks();
        $this->_inst_classes();
        register_activation_hook(APP_EXPERT_FILE, array($this, 'add_custom_render_page'));
    }
    public function _inst_classes(){
      //backend classes
      new App_Expert_Taxonomy_Image_Settings($this);
      new App_Expert_Taxonomy_image_form($this);
      //frontend classes
      new App_Expert_Page_Manager($this);
    }
    public function get_current_url(){
        return  APP_EXPERT_URL."includes/integrations/wordpress/";

    }
    public function get_current_path(){
        return APP_EXPERT_PATH."includes/integrations/wordpress/";
    }
    public function get_endponints_files(){
        /**
         * Add WordPress api just wrapped in app-expert name
         * To:
         *  - unify response structure
         *  - add extra data according to app needs
         **/
        return array_merge(
            parent::get_endponints_files(),
            glob($this->get_dir()."apis/response-meta-data/*.php"),
            glob($this->get_dir()."apis/wrapped-apis/*.php")
        );
    }
    public function add_custom_render_page(){
        // Add custom page renderer page
        if (!get_page_by_path(PAGE_RENDERER_SLUG)) {
            $post_details = array(
                'post_title'    => 'App Experts Page Renderer',
                'post_content'  => 'You are not authorized to access this page directly',
                'post_status'   => 'publish',
                'post_author'   => 1,
                'post_type' => 'page',
                'post_slug' => PAGE_RENDERER_SLUG
            );
            wp_insert_post($post_details);
        }

    }

    function get_dependencies()
    {
        return [];
    }
}
//todo:find a better way to create new object
new App_Expert_Wordpress_Init();